#
# spec file for package ddt (Version 0.5)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  apache-devel-packages bind8 bind8-devel gpp libgpp macrosystem ncurses-devel openssl openssl-devel postgresql-devel postgresql-libs readline-devel regexx
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim apache apache-devel autoconf automake bind8 bind8-devel binutils cracklib expat gcc gdbm gettext gpp libgpp libtool libz macrosystem mm mod_ssl openssl openssl-devel pam perl postgresql-devel postgresql-libs readline-devel regexx rpm

Name:         ddt
%define       apache_prefix %(apxs -q PREFIX)
%define       DDTCGIDIR %{apache_prefix}/ddt/
Version:      0.5
Release:      480
%define       opt_version 3.9
%define       cgi_version 0.5
Summary:      DDT (Dynamic DNS Tools) Server
License:      GPL
URL:          http://www.ddts.org/
Group:        Productivity/Networking/DNS/Utilities
# check these...
Requires:     postgresql postgresql-server regexx macrosystem 
Autoreqprov:  on
Source:       http://download.sourceforge.net/ddt/ddt-%{version}.tar.bz2
Source1:      ftp://nis-ftp.lanl.gov/pub/users/jt/Soft/opt-%{opt_version}.tar.bz2
Source2:      ftp://ftp.infodrom.north.de/pub/people/joey/cgilib/cgilib-%{cgi_version}.tar.bz2
Source5:      rc.ddtd
Source6:      rc.ddtcd
# use modifies templates (stripped URLs pointing to ddts.org)
Source9:      templates.SAMPLES.tar.bz2
Source10:     README.SuSE.ddt
Source11:     README.SuSE.ddt.client
Source12:     module.ddt
Source13:     ddt.conf
Source14:     apache.rc.config.ddt
# (1) fix a missing #include and 
# (2) bring ddt/configure.in in cplusplus mode before checking regexx.so and 
Patch:        ddt-0.5.dif
# The next patch casts a char pointer which is longint on ia64
Patch1:       cgilib-0.5.dif
# work around bug in readline-2.05, where __P is defined although already present in glibc
Patch2:       ddt-admin.cc.dif
# autoconf-1.5 fix
Patch3:       ddt-0.5-Makefile.am-autoconf-1.5.dif
# better defaults in cgi.conf and ddtd.conf
Patch4:       default-conf.dif
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
# Init scripts are in sbin for 7.0 or older, but in etc for 7.1 or newer
%define initdir %(if [ -x /sbin/insserv ]; then echo -n etc ; else echo -n sbin ; fi)/init.d
%package client
Summary:      DDT (Dynamic DNS Tools) Client
Group:        Productivity/Networking/DNS/Utilities
Requires:     net-tools 
Autoreqprov:  on

%description 
DDT is short for Dynamic Dns Tools. The goal of the project is to provide
an open and free (in the GPL-sense) set of tools that will permit the
deployment of secure and reliable dynamic DNS services.

It uses BIND8's dynamic update capabilities to provide authenticated
updates.

There are three parts to Dynamic DNS Tools:

1) the DDT client daemon, ddtcd, and the actual client, ddtc;
2) the DDT server daemon, ddtd, and the admin utility, ddt-admin; and
3) the CGI scripts used for web-based account registration and
administration.

Homepage of the project: http://www.ddts.org/

Authors:
--------
    Remi Lefebvre  <remi@ddts.org>
    Benoit Joly    <benoit@ddts.org>
    Luca Filipozzi <lfilipoz@ddts.org>

SuSE series: n


%description client
This is a client for DDT (Dynamic DNS Tools) servers. It can be used to
update an DNS entry of a host, that in fact has a dynamic IP address, in a
secure fashion. The communication between clients and server is encrypted
and authenticated, and the server uses the dynamic DNS update capabilities
of BIND8.

Homepage of the project: http://www.ddts.org/

Authors:
--------
    Remi Lefebvre  <remi@ddts.org>
    Benoit Joly    <benoit@ddts.org>
    Luca Filipozzi <lfilipoz@ddts.org>

SuSE series: n

%prep
%setup -n %{name}-%{version}
%setup -T -D -b 1
%setup -T -D -b 2
%setup -T -D -a 9
%patch
%patch2 
%patch3 
%patch4 -p1
pushd ../cgilib-%{cgi_version}
%patch1 
popd
## update autoconf, automake and libtool
## with macro from /usr/lib/rpm/suse_macros
%ifarch ia64 s390
	pushd ..
	DIR=$(find . -name configure -printf "%h\n")
	%{?suse_update_config:%{suse_update_config -f $DIR }}
	popd
%endif

%build
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
mkdir -p $RPM_BUILD_ROOT/var/run/ddt
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/lib
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/include
##
## cgilib
##
cd ../cgilib-%{cgi_version}
make 
install libcgi.a $RPM_BUILD_ROOT/%{_prefix}/lib/  
install cgi.h $RPM_BUILD_ROOT/%{_prefix}/include/  
## the install target only installs a test program
##
## libopt 
##
cd ../opt-%{opt_version}
./configure --prefix=$RPM_BUILD_ROOT/%{_prefix} --infodir=$RPM_BUILD_ROOT/%{_infodir}
make prefix=$RPM_BUILD_ROOT/%{_prefix}
make install
##
## ddt
##
cd ../ddt-%{version}
## Make sure that libs and headers can be found, the easy way
cp -alf $RPM_BUILD_ROOT/usr/include/*.h* framework/include/
cp -alf $RPM_BUILD_ROOT/usr/lib/lib* framework/lib/
rm -f config.cache
libtoolize --force
aclocal
automake --add-missing
autoconf
LIBS="$LIBS -L$RPM_BUILD_ROOT/usr/lib -I$RPM_BUILD_ROOT/usr/include" ./configure \
		--prefix=/%{_prefix} \
		--mandir=%{_mandir} \
		--infodir=%{_infodir} \
		--sysconfdir=%{_sysconfdir} \
		--with-pid-dir=/var/run/ \
		--with-log-dir=/var/log/ \
		--with-var-dir=/var/lib/ \
		--enable-admin \
		--enable-server \
		--with-pgsql=/%{_prefix}/include/pgsql \
		--with-pgsql-include=/%{_prefix}/include/pgsql \
		--with-pgsql-lib=/%{_prefix}/lib 
## --enable-admin needs cgilib and regexx and postgresql-devel
## --enable-server needs libbind (bind8), don't know if bind9 also works
## --enable-docs needs at least these, but that's currently broken:
##     sgmltools-lite openjade iso-ent docbk30 docbk_4 docbkdsl jade_dsl
## On a 6.4 you need:
##		--with-pgsql=/%{_prefix}/lib/pgsql/ \
##		--with-pgsql-include=/%{_prefix}/lib/pgsql/include/ \
##		--with-pgsql-lib=/%{_prefix}/lib
## Furthermore, libpq++.h was /usr/lib/pgsql/include/libpq++.H in 6.4 
#[ -f /usr/lib/pgsql/include/libpq++.H ] && ln -sf libpq++.H /usr/lib/pgsql/include/libpq++.h
make CFLAGS="$CFLAGS $RPM_OPT_FLAGS" 
strip --strip-all admin/ddt-admin server/ddtd client/ddtc{,d}

%install
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/%{initdir}
mkdir -p $RPM_BUILD_ROOT/var/run/ddt
mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
mkdir -p $RPM_BUILD_ROOT/%{DDTCGIDIR}/templates
mkdir -p $RPM_BUILD_ROOT/%{DDTCGIDIR}/templates.SAMPLES
install -m 755 $RPM_SOURCE_DIR/rc.ddtd	$RPM_BUILD_ROOT/%{initdir}/ddtd
install -m 755 $RPM_SOURCE_DIR/rc.ddtcd	$RPM_BUILD_ROOT/%{initdir}/ddtcd
ln -sf ../../%{initdir}/ddtd 	$RPM_BUILD_ROOT/usr/sbin/rcddtd
ln -sf ../../%{initdir}/ddtcd 	$RPM_BUILD_ROOT/usr/sbin/rcddtcd
install -m 755 admin/ddt-admin	$RPM_BUILD_ROOT/%{_sbindir}/
install -s -m 755 admin/admin.cgi	$RPM_BUILD_ROOT/%{DDTCGIDIR}/
ln -sf admin.cgi			$RPM_BUILD_ROOT/%{DDTCGIDIR}/register.cgi
install -m 600 admin/cgi.conf 		$RPM_BUILD_ROOT/%{DDTCGIDIR}/
install -m 600 admin/ddt.ban 		$RPM_BUILD_ROOT/%{DDTCGIDIR}/
install -m 644 templates.SAMPLES/*	$RPM_BUILD_ROOT/%{DDTCGIDIR}/templates.SAMPLES/
install -m 755 admin/ddtbot.pl 		$RPM_BUILD_ROOT/%{_sbindir}/
install -m 600 admin/ddtbot.conf 	$RPM_BUILD_ROOT/%{_sysconfdir}/
install -d -m 755 $RPM_BUILD_ROOT/etc/httpd/modules
install -m 644 $RPM_SOURCE_DIR/ddt.conf 	$RPM_BUILD_ROOT/etc/httpd/
install -m 644 $RPM_SOURCE_DIR/module.ddt 	$RPM_BUILD_ROOT/etc/httpd/modules/ddt
install -m 644 admin/ddt-admin.8 $RPM_BUILD_ROOT/%{_mandir}/man8/
cp -p $RPM_SOURCE_DIR/README.SuSE.ddt 		README.SuSE
cp -p $RPM_SOURCE_DIR/README.SuSE.ddt.client 	client/README.SuSE
install -m 644 $RPM_SOURCE_DIR/apache.rc.config.ddt 	$RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.apache-ddt
touch $RPM_BUILD_ROOT/var/run/ddt/ddtd.pid
touch $RPM_BUILD_ROOT/var/run/ddt/ddtcd.pid
touch $RPM_BUILD_ROOT/var/run/ddt/ddtbot.pid
touch filelist{,.client}
if ! [ -x /sbin/insserv ] ; then
	# Create symbolic run level links (7.0 or older)
	rm -f $RPM_BUILD_ROOT/sbin/init.d/rc*.d/*ddtd
	mkdir -p $RPM_BUILD_ROOT/sbin/init.d/rc{2,3}.d
	ln -s ../ddtd $RPM_BUILD_ROOT/sbin/init.d/rc2.d/S30ddtd
	ln -s ../ddtd $RPM_BUILD_ROOT/sbin/init.d/rc2.d/K30ddtd
	ln -s ../ddtd $RPM_BUILD_ROOT/sbin/init.d/rc3.d/S30ddtd
	ln -s ../ddtd $RPM_BUILD_ROOT/sbin/init.d/rc3.d/K30ddtd
	rm -f $RPM_BUILD_ROOT/sbin/init.d/rc*.d/*ddtcd
	ln -s ../ddtcd $RPM_BUILD_ROOT/sbin/init.d/rc2.d/S30ddtcd
	ln -s ../ddtcd $RPM_BUILD_ROOT/sbin/init.d/rc2.d/K30ddtcd
	ln -s ../ddtcd $RPM_BUILD_ROOT/sbin/init.d/rc3.d/S30ddtcd
	ln -s ../ddtcd $RPM_BUILD_ROOT/sbin/init.d/rc3.d/K30ddtcd
	echo /sbin/init.d/rc2.d/S30ddtd >> filelist
	echo /sbin/init.d/rc2.d/K30ddtd >> filelist
	echo /sbin/init.d/rc3.d/S30ddtd >> filelist
	echo /sbin/init.d/rc3.d/K30ddtd >> filelist
	echo /sbin/init.d/rc2.d/S30ddtcd >> filelist.client
	echo /sbin/init.d/rc2.d/K30ddtcd >> filelist.client
	echo /sbin/init.d/rc3.d/S30ddtcd >> filelist.client
	echo /sbin/init.d/rc3.d/K30ddtcd >> filelist.client
fi

%clean
rm -rf $RPM_BUILD_ROOT

%post 
%{fillup_and_insserv ddtd}
%{fillup_only -an apache}

%postun
%{insserv_cleanup}

%post client
%{fillup_and_insserv ddtcd}

%postun client
%{insserv_cleanup}

%preun 
touch var/run/ddt/ddtd.pid
touch var/run/ddt/ddtbot.pid

%preun client
touch var/run/ddt/ddtcd.pid

%files -f filelist
%{_sbindir}/ddtd
%{_sbindir}/rcddtd
%{_sbindir}/ddtbot.pl
%{_sbindir}/ddt-admin
%config /%{initdir}/ddtd
%dir /var/run/ddt
%attr(644,root,root) %ghost /var/run/ddt/ddtd.pid
%attr(644,root,root) %ghost /var/run/ddt/ddtbot.pid
%config(noreplace) %dir %attr(755,root,root) %{DDTCGIDIR}
%{DDTCGIDIR}/admin.cgi
%{DDTCGIDIR}/register.cgi
%attr(600,root,root)%config(noreplace) %{_sysconfdir}/ddtd.conf
%attr(600,root,root)%config(noreplace) %{_sysconfdir}/ddtbot.conf
%attr(600,wwwrun,nogroup)%config(noreplace) %{DDTCGIDIR}/cgi.conf
%attr(600,wwwrun,nogroup)%config(noreplace) %{DDTCGIDIR}/ddt.ban
%dir %attr(755,root,root)%config(noreplace) %{DDTCGIDIR}/templates/
%attr(644,root,root)%config(noreplace) %{DDTCGIDIR}/templates.SAMPLES/*
/etc/httpd/modules/ddt
%config(noreplace) /etc/httpd/ddt.conf
/var/adm/fillup-templates/sysconfig.apache-ddt
%doc %{_mandir}/man8/ddtd.8.gz
%doc %{_mandir}/man8/ddt-admin.8.gz
%doc AUTHORS BUGS COPYING debian/changelog INSTALL NEWS README THANKS TODO README.SuSE
%doc docs
/usr/include/cgi.h
/usr/include/opt.h
/usr/lib/libcgi.a
/usr/lib/libopt.a
/%{_infodir}/opt.info.gz

%files client -f filelist.client
%{_sbindir}/ddtc
%{_sbindir}/ddtcd
%config /%{initdir}/ddtcd
/usr/sbin/rcddtcd
%attr(600,root,root) %config(noreplace) %{_sysconfdir}/ddtcd.conf
%dir /var/run/ddt
%attr(644,root,root) %ghost /var/run/ddt/ddtcd.pid
%doc %{_mandir}/man8/ddtc.8.gz
%doc %{_mandir}/man8/ddtcd.8.gz
%doc AUTHORS BUGS COPYING debian/changelog INSTALL NEWS README THANKS TODO client/README.SuSE

%changelog -n ddt
* Thu Apr 17 2003 - poeml@suse.de
- fix unsafe usage of /var/tmp by the init scripts [cf. #25241]
* Sat Feb 02 2002 - poeml@suse.de
- replace GmbH --> AG
* Mon Jan 28 2002 - ro@suse.de
- define TRUE if not defined in DbAdmin.cc (for new postgres)
* Mon Jan 14 2002 - ro@suse.de
- removed START_DDTD and START_DDTCD
- adapted for move to /etc/sysconfig/apache
* Wed Nov 07 2001 - poeml@suse.de
- fixes for automake 1.5:
  * don't use += in Makefile.am
  * get depcomp with --add-missing
  * drop obsolete hunk for Makefile.in
- use apache-devel-packages macro for #neededforbuild
  (apxs -q fails without expat.rpm)
- add more hints on the installation to README.SuSE
- move DDTCGIDIR out of the docroot (now: /usr/local/httpd/ddt)
- move templates to templates.SAMPLES
- provide /etc/httpd/ddt.conf for apache and a variable in
  apache.rc.config
* Sat Nov 03 2001 - poeml@suse.de
- fix mistyped apache docroot in README.SuSE (thanks lmuelle)
* Thu Jul 26 2001 - kukuk@suse.de
- Fix needed for build
* Wed Jun 13 2001 - poeml@suse.de
- use 'libtoolize --force' due to new autotools
- server package: add dependency on postgresql-server
- rc scripts: remove startproc-logfile before each start
- add a small hint to README.SuSE
* Mon Apr 23 2001 - poeml@suse.de
- correct apache docroot in README.SuSE
* Mon Apr 16 2001 - poeml@suse.de
- #undef __P to work around bug in readline-2.05 (it uses its own
  __P while there is one in the glibc already) -thanks to Andreas!
- fix init scripts according to new /etc/rc.status
- don't require apache and net_tools
* Sun Apr 01 2001 - poeml@suse.de
- use apxs to determine apache docroot
- add README.SuSE for client subpackage
* Wed Mar 28 2001 - poeml@suse.de
- fix mising brackets in init scripts (reload section)
* Thu Mar 22 2001 - poeml@suse.de
- server:
  * refine README.SuSE
  * change client port in template to the one in the conf files
- remove stray .swp file
* Thu Mar 22 2001 - poeml@suse.de
- new package
